# cloudwatchlogs_log_group – create or delete log_group in CloudWatchLogs

New in version 2.5.

- Synopsis

- Requirements

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- Create or delete log_group in CloudWatchLogs.

## Requirements

The below requirements are needed on the host that executes this module.

- boto

- boto3

- botocore

- json

- python >= 2.6

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
aws_access_key string |  | AWS access key. If not set then the value of the AWS_ACCESS_KEY_ID, AWS_ACCESS_KEY or EC2_ACCESS_KEY environment variable is used. aliases: ec2_access_key, access_key
aws_secret_key string |  | AWS secret key. If not set then the value of the AWS_SECRET_ACCESS_KEY, AWS_SECRET_KEY, or EC2_SECRET_KEY environment variable is used. aliases: ec2_secret_key, secret_key

debug_botocore_endpoint_logs
boolean
added in 2.8

Choices:
- no ←
- yes

Use a botocore.endpoint logger to parse the unique (rather than total) "resource:action" API calls made during a task, outputing the set to the resource_actions key in the task results. Use the aws_resource_action callback to output to total list made during a playbook. The ANSIBLE_DEBUG_BOTOCORE_LOGS environment variable may also be used.

ec2_url string |  | Url to use to connect to EC2 or your Eucalyptus cloud (by default the module will use EC2 endpoints). Ignored for modules where region is required. Must be specified for all other modules if region is not used. If not set then the value of the EC2_URL environment variable, if any, is used.
kms_key_id - |  | The Amazon Resource Name (ARN) of the CMK to use when encrypting log data.
log_group_name - / required |  | The name of the log group.

overwrite
boolean

Choices:
- no ←
- yes

Whether an existing log group should be overwritten on create.

profile string |  | Uses a boto profile. Only works with boto >= 2.24.0.
region string |  | The AWS region to use. If not specified then the value of the AWS_REGION or EC2_REGION environment variable, if any, is used. See http://docs.aws.amazon.com/general/latest/gr/rande.html#ec2_region aliases: aws_region, ec2_region
retention - |  | The number of days to retain the log events in the specified log group. Valid values are: [1, 3, 5, 7, 14, 30, 60, 90, 120, 150, 180, 365, 400, 545, 731, 1827, 3653]
security_token string |  | AWS STS security token. If not set then the value of the AWS_SECURITY_TOKEN or EC2_SECURITY_TOKEN environment variable is used. aliases: access_token

state
-

Choices:
- present ←
- absent

Whether the rule is present, absent or get

tags - |  | The key-value pairs to use for the tags.

validate_certs
boolean

Choices:
- no
- yes ←

When set to "no", SSL certificates will not be validated for boto versions >= 2.6.0.

## Notes

Note

- for details of the parameters and returns see http://boto3.readthedocs.io/en/latest/reference/services/logs.html

- If parameters are not set within the module, the following environment variables can be used in decreasing order of precedence `AWS_URL` or `EC2_URL`, `AWS_ACCESS_KEY_ID` or `AWS_ACCESS_KEY` or `EC2_ACCESS_KEY`, `AWS_SECRET_ACCESS_KEY` or `AWS_SECRET_KEY` or `EC2_SECRET_KEY`, `AWS_SECURITY_TOKEN` or `EC2_SECURITY_TOKEN`, `AWS_REGION` or `EC2_REGION`

- Ansible uses the boto configuration file (typically ~/.boto) if no credentials are provided. See https://boto.readthedocs.io/en/latest/boto_config_tut.html

- `AWS_REGION` or `EC2_REGION` can be typically be used to specify the AWS region, when required, but this can also be configured in the boto config file

## Examples

    # Note: These examples do not set authentication details, see the AWS Guide for details.

    - cloudwatchlogs_log_group:
        log_group_name: test-log-group

    - cloudwatchlogs_log_group:
        state: present
        log_group_name: test-log-group
        tags: { "Name": "test-log-group", "Env" : "QA" }

    - cloudwatchlogs_log_group:
        state: present
        log_group_name: test-log-group
        tags: { "Name": "test-log-group", "Env" : "QA" }
        kms_key_id: arn:aws:kms:region:account-id:key/key-id

    - cloudwatchlogs_log_group:
        state: absent
        log_group_name: test-log-group

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
log_groups complex | success | Return the list of complex objects representing log groups
| arn string | always | The Amazon Resource Name (ARN) of the log group.
| creation_time integer | always | The creation time of the log group.
| kms_key_id string | always | The Amazon Resource Name (ARN) of the CMK to use when encrypting log data.
| log_group_name string | always | The name of the log group.
| metric_filter_count integer | always | The number of metric filters.
| retention_in_days integer | always | The number of days to retain the log events in the specified log group.
| stored_bytes string | always | The number of bytes stored.

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Community. [community]

### Authors

- Willian Ricardo (@willricardo) <willricardo@gmail.com>

Hint

If you notice any issues in this documentation, you can edit this document to improve it.